#ifndef CHEAPCLOCK_H
#define CHEAPCLOCK_H
#include<sys/time.h>
#include<stdint.h>
#include<iostream>
#include"TSCtimestamp.h"

class CheapClock
{
public:
  CheapClock()
    {
      thr2_=getTSCtimestamp();
      gettimeofday(&tsys2_,0);
    }
  void gettime(struct timeval& ret)
  { 
    // T=(Thr-thr2)*(tsys2-tsys1)/(thr2-thr1)+tsys2
    TSCTimestamp_t thr = getTSCtimestamp();
    uint64_t current_us = ((thr-thr2_)<<10)/invcorrelationfactor_;
    uint64_t a_us = tsys2_.tv_usec+current_us;
    ret.tv_sec  = tsys2_.tv_sec+a_us/1000000ULL;
    ret.tv_usec = a_us%1000000ULL;
  }

  void timesample(const struct timeval& sample)
  {
    //??? idee: ignorierung wenn thr2_-thr1_ < min
    tsys1_=tsys2_;
    tsys2_=sample;
    thr1_=thr2_;
    thr2_=getTSCtimestamp();
    uint64_t hrdiff = thr2_-thr1_;
    hrdiff<<=10;  // hrdiff wird erhoeht um stellenabscheidung zu vermeiden
    uint64_t systimediffus = (uint64_t)(tsys2_.tv_sec-tsys1_.tv_sec)*1000000ULL+(tsys2_.tv_usec-tsys1_.tv_usec);
    invcorrelationfactor_= hrdiff/systimediffus;
  }
  uint64_t invcorrelationfactor() { return invcorrelationfactor_; }  
private:
  TSCTimestamp_t thr1_;
  TSCTimestamp_t thr2_;
  struct timeval tsys1_;
  struct timeval tsys2_;
  uint64_t invcorrelationfactor_; // dim ticks/ns
};
#endif
