#ifndef RUSAGECMP_H
#define RUSAGECMP_H
#include <sys/time.h>
#include <sys/resource.h>
#include <iostream>
#include <string.h>
#include <errno.h>

#include "timevalhelper.h"

class RusageCMP
{
public:
    RusageCMP()
    {
	int r=getrusage(RUSAGE_SELF,&vorher_);
	if(r<0) { std::clog << "rusage: " << strerror(errno) << std::endl; }
    }
    void stop()
    {
	int r=getrusage(RUSAGE_SELF,&nachher_);
	if(r<0) { std::clog << "rusage: " << strerror(errno) << std::endl; }

    }
    void analyse()
    {
#if 0
	std::cout << "Rusage vorher: ";dump(vorher_);
	std::cout << "Rusage nacher: ";dump(nachher_);
#endif 
	struct timeval udiff;
	struct timeval sdiff;
	timeval_substract(udiff,nachher_.ru_utime,vorher_.ru_utime);
	timeval_substract(sdiff,nachher_.ru_stime,vorher_.ru_stime);
	long fkw = nachher_.ru_nvcsw-vorher_.ru_nvcsw;
	long ukw = nachher_.ru_nivcsw-vorher_.ru_nivcsw;
	std::cout << "User time: " << udiff << std::endl;
	std::cout << "System time: " << sdiff << std::endl;
	std::cout << "Kontextwechsel: " << fkw << " freiwillig, " 
                  << ukw << " unfreiwillig" << std::endl;
    }
private:
    struct rusage vorher_;
    struct rusage nachher_;
    void dump(const struct rusage& usage)
    {
	std::cout << "User time:\t" << usage.ru_utime.tv_sec << ':' 
		                   << usage.ru_utime.tv_usec
		                   << std::endl;
	std::cout << "System time:\t" << usage.ru_stime.tv_sec << ':' 
		                     << usage.ru_stime.tv_usec
		                     << std::endl;
	std::cout << "Voluntary CS:\t" << usage.ru_nvcsw << std::endl;
	std::cout << "Involuntary CS\t" << usage.ru_nivcsw << std::endl;
    }
};
#endif
