#ifndef TSCTIMESTAMP_H
#define TSCTIMESTAMP_H
#include <stdint.h>
typedef uint64_t TSCTimestamp_t;

inline TSCTimestamp_t getTSCtimestamp()
{
#ifdef __x86_64
     uint32_t eax,edx;
     asm volatile ("rdtsc" : "=a" (eax), "=d" (edx) : : "memory");
     return  (((uint64_t) eax) | (((uint64_t) edx) << 32));
#elif __i586
     /* http://www.tldp.org/HOWTO/IO-Port-Programming-4.html */
     TSCTimestamp_t x;
     __asm__ __volatile__ ("rdtsc" : "=A" (x));
     return x;
#else
   #error "please implement getTSCtimestamp for your architecture"
#endif
}
#endif
