#include<iostream>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include"CheapClock_TSC.h"

int main(int argc,char **argv)
{
  char **arg = argv+1;
  double fins=1.0;
  bool exprandom=false;
  if(*arg!=0)
  {
    if(strcmp(*arg,"random")==0)
    {
      exprandom=true;
    }
    else
    {
      char *e=0;
      fins=strtod(*arg,&e);
    }
  }
  double finns =fins*1E9; // ns
  struct timespec checkinterval;
  checkinterval.tv_sec = (time_t)fins;
  checkinterval.tv_nsec = (long)(finns - checkinterval.tv_sec*1E9);
  std::clog << "Intervall (s:ns)=" << checkinterval.tv_sec
            << ":" << checkinterval.tv_nsec
	    << std::endl;
  CheapClock cheapclock;
  nanosleep(&checkinterval,0);
  TSCTimestamp_t vorgtof = getTSCtimestamp();
  struct timeval currentgtofday;
  struct timeval currentcheap;
  gettimeofday(&currentgtofday,0);
  TSCTimestamp_t nachgtof = getTSCtimestamp();
  cheapclock.timesample(currentgtofday);
  TSCTimestamp_t nachts = getTSCtimestamp();
  cheapclock.gettime(currentcheap);
  TSCTimestamp_t nachcc = getTSCtimestamp();
  TSCTimestamp_t kgtof = nachgtof - vorgtof;
  TSCTimestamp_t kts   = nachts-nachgtof;
  TSCTimestamp_t kcc   = nachcc-nachts;
  std::clog << "Kosten gettimeofday = " << kgtof << " ticks" << std::endl;
  std::clog << "Kosten timesample   = " << kts << " ticks" << std::endl;
  std::clog << "kosten cheapclock   = " << kcc << " ticks" << std::endl;
  std::clog << "cheapclockinitialized ..." << std::endl;
  std::clog << "s gettimeofday\ts cheapclock\tdiff\tinvcorr" << std::endl;
  while(1)
  {
    if(exprandom)
    {
      // exponentialverteilte Zufallszeiten ab 500 ms
      double r = 500-2000*log((double)random()/(double)RAND_MAX);
      checkinterval.tv_sec = (long)r/1000;
      double rnsec=r-checkinterval.tv_sec*1000;
      checkinterval.tv_nsec = (rnsec*1000000.0);
      std::clog << "testcheckinterval = " << r << "ms "
		<< " (" << checkinterval.tv_sec
		<< ':' << checkinterval.tv_nsec
		<< ')' << std::endl;
    }
    nanosleep(&checkinterval,0); 
    cheapclock.gettime(currentcheap);
    gettimeofday(&currentgtofday,0);
    cheapclock.timesample(currentgtofday);
    double diff =  currentcheap.tv_sec*1E6+currentcheap.tv_usec
                   -(currentgtofday.tv_sec*1E6+currentgtofday.tv_usec);
    std::cout << currentgtofday.tv_sec << '\t'
	      << currentcheap.tv_sec << "\t" << diff << "us\t"
              << cheapclock.invcorrelationfactor() << "ticks/us"
	      << std::endl;

  }
}
