#include<iostream>
#include<stdlib.h>
#include"CheapClock_TSC.h"
#include "RusageCmp.h"

int main(int argc,char **argv)
{
  int N=100;
  if(argc > 1)
  {
      N = strtol(argv[1],0,10);
  }
  std::clog << "N=" << N << std::endl;
  CheapClock cheapclock;
  struct timeval currentgtofday;
  /*-------------- clock_gettime CLOCK_MONOTONIC --------------*/
  {
    struct timespec ts;
    RusageCMP rusagecmp;
    TSCTimestamp_t vorNgtof = getTSCtimestamp();
    for(int i=0;i<N;i++)
    {
	clock_gettime(CLOCK_MONOTONIC,&ts);
    }
    TSCTimestamp_t nachNgtof = getTSCtimestamp();
    TSCTimestamp_t ticksNgtof = nachNgtof-vorNgtof;
    double mgtof = ticksNgtof/double(N);
    rusagecmp.stop();
    std::cout << "N*clock_gettime(CLOCK_MONOTONIC) " << ticksNgtof << " ticks"
	      << " 1*clock_gettime(CLOCK_MONOTONIC) " << mgtof << " ticks" << std::endl;
    rusagecmp.analyse();
  }
  /*-------------- clock_gettime CLOCK_REALTIME --------------*/
  {
    struct timespec ts;
    RusageCMP rusagecmp;
    TSCTimestamp_t vorNgtof = getTSCtimestamp();
    for(int i=0;i<N;i++)
    {
	clock_gettime(CLOCK_REALTIME,&ts);
    }
    TSCTimestamp_t nachNgtof = getTSCtimestamp();
    TSCTimestamp_t ticksNgtof = nachNgtof-vorNgtof;
    double mgtof = ticksNgtof/double(N);
    rusagecmp.stop();
    std::cout << "N*clock_gettime(CLOCK_REALTIME) " << ticksNgtof << " ticks"
	      << " 1*clock_gettime(CLOCK_REALTIME) " << mgtof << " ticks" << std::endl;
    rusagecmp.analyse();
  }
  /*-------------- gettimeofday ---------------*/
  {
    RusageCMP rusagecmp;
    TSCTimestamp_t vorNgtof = getTSCtimestamp();
    for(int i=0;i<N;i++)
      {
	gettimeofday(&currentgtofday,0);
      }
    TSCTimestamp_t nachNgtof = getTSCtimestamp();
    TSCTimestamp_t ticksNgtof = nachNgtof-vorNgtof;
    double mgtof = ticksNgtof/double(N);
    rusagecmp.stop();
    std::cout << "N*gettimeofday " << ticksNgtof << " ticks"
	      << " 1*getimeofday " << mgtof << " ticks" << std::endl;
    rusagecmp.analyse();
  }
  std::clog << "Calibrating ... " << std::endl;
  struct timespec checkinterval = { 1,0};
  nanosleep(&checkinterval,0);
  gettimeofday(&currentgtofday,0);
  cheapclock.timesample(currentgtofday);
  {
    RusageCMP rusagecmp;
    TSCTimestamp_t vorNck = getTSCtimestamp();
    struct timeval currentcheap;
    for(int i=0;i<N;i++)
    {
	cheapclock.gettime(currentcheap);
    }
    TSCTimestamp_t nachNck = getTSCtimestamp();
    TSCTimestamp_t ticksNck = nachNck-vorNck;
    double mck = ticksNck/double(N);
    rusagecmp.stop();
    std::cout << "N*cheap.gettime " << ticksNck << " ticks"
	      << " 1*cheap.gettime " << mck << " ticks" << std::endl;
    rusagecmp.analyse();
  }
  {
    RusageCMP rusagecmp;
    time_t t = currentgtofday.tv_sec;
    TSCTimestamp_t vorNts = getTSCtimestamp();
    for(int i=0;i<N;i++)
    {
      currentgtofday.tv_sec = ++t;
      cheapclock.timesample(currentgtofday);
    }
    TSCTimestamp_t nachNts = getTSCtimestamp();
    TSCTimestamp_t ticksNts = nachNts-vorNts;
    double mts = ticksNts/double(N);
    rusagecmp.stop();
    std::cout << "N*cheap.timesample " << ticksNts << " ticks"
	      << " 1*cheap.timesample " << mts << " ticks" << std::endl;
    rusagecmp.analyse();
  }
}
